## lilyterm 0.9.9.4

=== Makefile ===
include .default
-include .config

DIR = src data

ifeq ($(NLS), Y)
DIR += po
endif

.PHONY: all
all: $(DIR)

.PHONY: src
src:
	@ $(MAKE) -C src

.PHONY: data
data:
	@ $(MAKE) -C data

.PHONY: po
po:
	@ $(MAKE) -C po

clean:
	@ $(MAKE) -C src clean
	@ $(MAKE) -C data clean
	@ $(MAKE) -C po clean

install: all
	@ $(MAKE) -C src install
	@ $(MAKE) -C data install
ifeq ($(NLS), Y)
	@ $(MAKE) -C po install
endif

uninstall:
	@ $(MAKE) -C src uninstall
	@ $(MAKE) -C data uninstall
ifeq ($(NLS), Y)
	@ $(MAKE) -C po uninstall
endif
	@ if [ -z "`ls -A "$(DESTDIR)/$(PREFIX)"`" ]; then \
		$(ECHO) "===========================================" ; \
		$(PRINTF) "\033[1;31m** WARNING: \"$(DESTDIR)/$(PREFIX)\" is empty. Please remove it manually if necessary.\033[0m\n" ; \
		$(ECHO) "===========================================" ; \
	fi
distclean: clean
	@ if [ -f .config ]; then \
		$(PRINTF) "\033[1;35m** deleting .config...\033[0m\n" ; \
		rm .config ; \
	fi

=== data/Makefile ===
include ../.default
-include ../.config

DESKTOP_DIR ?= $(DATADIR)/applications
GNOME_CONTROL_CENTER ?= Y
GNOME_CONTROL_CENTER_DIR ?= $(DATADIR)/gnome-control-center/default-apps

MAIN_BINARY := $(shell if [ -f ../src/$(BINARY)_dev ]; then echo $(BINARY)_dev; fi)
MAIN_BINARY := $(shell if [ -f ../src/$(BINARY)_dbg ]; then echo $(BINARY)_dbg; fi)
ifeq ($(MAIN_BINARY), )
MAIN_BINARY = $(BINARY)
endif

RomveFileList = $(DESTDIR)/$(ETCDIR)/$(BINARY).conf \
		$(DESTDIR)/$(DOCDIR)/AUTHORS \
		$(DESTDIR)/$(DOCDIR)/COPYING \
		$(DESTDIR)/$(DOCDIR)/ChangeLog \
		$(DESTDIR)/$(MANDIR)/$(BINARY).1.gz \
		$(DESTDIR)/$(DESKTOP_DIR)/$(BINARY).desktop \
		$(DESTDIR)/$(ICONDIR)/$(BINARY).png \
		$(DESTDIR)/$(ICONDIR)/$(BINARY).xpm \
		$(DESTDIR)/$(EXAMPLES_DIR)/$(BINARY).conf
ifeq ($(GNOME_CONTROL_CENTER), Y)
ifneq ($(GNOME_CONTROL_CENTER_DIR), )
RomveFileList += $(DESTDIR)/$(GNOME_CONTROL_CENTER_DIR)/$(BINARY).xml
endif
endif

.PHONY: all
all: $(BINARY).conf $(BINARY).1.gz

$(BINARY).conf:
	# @ if [ ! -f ../src/$(BINARY) -a \
	#     ! -f ../src/$(BINARY)_dbg -a \
	#     ! -f ../src/$(BINARY)_dev ]; then \
	#	cd ../src ; \
	#	$(MAKE) ; \
	# fi
	# @ $(PRINTF) "\033[1;33m** creating $(BINARY).conf...\033[0m\n"
	# @ ../src/$(MAIN_BINARY) -p > $(BINARY).conf

$(BINARY).1.gz:
	@ if [ -f $(BINARY).1 ]; then \
		$(PRINTF) "\033[1;33m** adding $(BINARY).1...\033[0m\n" ; \
		gzip $(BINARY).1 ; \
	fi

.PHONY: clean
clean:
	@ # @ if [ -f $(BINARY).conf ]; then \
	#	$(PRINTF) "\033[1;35m** deleteing $(BINARY).conf...\033[0m\n" ; \
	#	rm $(BINARY).conf ; \
	# fi
	@ if [ -f $(BINARY).1.gz ]; then \
		$(PRINTF) "\033[1;35m** unziping $(BINARY).1...\033[0m\n" ; \
		gzip -d  $(BINARY).1.gz ; \
	fi

.PHONY: install
install: all
	@ $(PRINTF) "\033[1;33m** installing $(BINARY).conf to $(DESTDIR)/$(ETCDIR)...\033[0m\n"
	@ install -d $(DESTDIR)/$(ETCDIR)
	@ install -m 644 $(BINARY).conf $(DESTDIR)/$(ETCDIR)

	@ $(PRINTF) "\033[1;33m** installing AUTHORS COPYING ChangeLog to $(DESTDIR)/$(DOCDIR)...\033[0m\n"
	@ install -d $(DESTDIR)/$(DOCDIR)
	@ install -m 644 ../AUTHORS ../COPYING ../ChangeLog $(DESTDIR)/$(DOCDIR)

	@ $(PRINTF) "\033[1;33m** installing $(BINARY).1.gz to $(DESTDIR)/$(MANDIR)...\033[0m\n"
	@ install -d $(DESTDIR)/$(MANDIR)
	@ install -m 644 $(BINARY).1.gz $(DESTDIR)/$(MANDIR)

	@ $(PRINTF) "\033[1;33m** installing $(BINARY).desktop to $(DESTDIR)/$(DESKTOP_DIR)...\033[0m\n"
	@ install -d $(DESTDIR)/$(DESKTOP_DIR)
	@ install -m 644  $(BINARY).desktop $(DESTDIR)/$(DESKTOP_DIR)

	@ $(PRINTF) "\033[1;33m** installing $(BINARY).png $(BINARY).xpm to $(DESTDIR)/$(ICONDIR)...\033[0m\n"
	@ install -d $(DESTDIR)/$(ICONDIR)
	@ install -m 644 $(BINARY).png $(BINARY).xpm $(DESTDIR)/$(ICONDIR)

	@ $(PRINTF) "\033[1;33m** installing $(BINARY).conf to $(DESTDIR)/$(EXAMPLES_DIR)...\033[0m\n"
	@ install -d $(DESTDIR)/$(EXAMPLES_DIR)
	@ install -m 644 $(BINARY).conf $(DESTDIR)/$(EXAMPLES_DIR)

ifeq ($(GNOME_CONTROL_CENTER), Y)
    ifneq ($(GNOME_CONTROL_CENTER_DIR), )
	@ $(PRINTF) "\033[1;33m** installing $(BINARY).xml to $(DESTDIR)/$(GNOME_CONTROL_CENTER_DIR)...\033[0m\n"
	@ install -d $(DESTDIR)/$(GNOME_CONTROL_CENTER_DIR)
	@ install -m 644 $(BINARY).xml $(DESTDIR)/$(GNOME_CONTROL_CENTER_DIR)
    endif
endif

.PHONY: uninstall
uninstall:
	@ - for FileName in $(RomveFileList) ; do \
		if [ -f "$$FileName" ]; then \
			$(PRINTF) "\033[1;35m** deleting $$FileName...\033[0m\n" ; \
			rm -f "$$FileName" ; \
			DirName=`dirname $$FileName` ; \
			until [ -n "`ls -A $$DirName`" -o "$$DirName" = "$(DESTDIR)/$(PREFIX)" ]; do \
				$(PRINTF) "\033[1;35m** deleting $$DirName...\033[0m\n" ; \
				rmdir "$$DirName" ; \
				DirName=`dirname $$DirName` ; \
			done \
		else \
			$(PRINTF) "\033[1;31m** $$FileName is NOT exist!\033[0m\n"; \
		fi ; \
	done

=== po/Makefile ===
include ../.default
-include ../.config

PO_LIST ?= $(LANG_LIST:=.po)
MO_LIST ?= $(LANG_LIST:=.mo)

XGETTEXT := $(shell whereis "xgettext" | tr -s ' ' '\n' | grep "bin/""xgettext""$$" | head -n 1)
ifneq ($(XGETTEXT), )

XGETTEXT_PARAMETER = -k_

SUPPORT_FROM_CODE = $(shell $(XGETTEXT) --help | grep -q -- '--from-code' && echo Y)
ifeq ($(SUPPORT_FROM_CODE), Y)
	XGETTEXT_PARAMETER += --from-code=UTF-8
endif

SUPPORT_COPYRIGHT_HOLDER = $(shell $(XGETTEXT) --help | grep -q -- '--copyright-holder' && echo Y)
ifeq ($(SUPPORT_COPYRIGHT_HOLDER), Y)
	XGETTEXT_PARAMETER += --copyright-holder="$(YEAR) FULL NAME <EMAIL@ADDRESS>"
endif

SUPPORT_PACKAGE_NAME = $(shell $(XGETTEXT) --help | grep -q -- '--package-name' && echo Y)
ifeq ($(SUPPORT_PACKAGE_NAME), Y)
	XGETTEXT_PARAMETER += --package-name=$(PACKAGE)
endif

SUPPORT_PACKAGE_VERSION = $(shell $(XGETTEXT) --help | grep -q -- '--package-version' && echo Y)
ifeq ($(SUPPORT_PACKAGE_VERSION), Y)
	XGETTEXT_PARAMETER += --package-version="$(VER)"
endif

endif

MSGCMP := $(shell whereis "msgcmp" | tr -s ' ' '\n' | grep "bin/""msgcmp""$$" | head -n 1)
ifneq ($(MSGCMP), )

SUPPORT_USE_UNTRANSLATED = $(shell $(MSGCMP) --help | grep -q -- '--use-untranslated' && echo Y)
ifeq ($(SUPPORT_USE_UNTRANSLATED), Y)
	MSGCMP_PARAMETER += --use-untranslated
endif

endif

MSGMERGE := $(shell whereis "msgmerge" | tr -s ' ' '\n' | grep "bin/""msgmerge""$$" | head -n 1)
ifneq ($(MSGMERGE), )

SUPPORT_PREVIOUS = $(shell $(MSGMERGE) --help | grep -q -- '--previous' && echo Y)
ifeq ($(SUPPORT_PREVIOUS), Y)
	MSGMERGE_PARAMETER += --previous
endif

endif

MSGFMT := $(shell whereis "msgfmt" | tr -s ' ' '\n' | grep "bin/""msgfmt""$$" | head -n 1)
TOUCH := $(shell whereis "touch" | tr -s ' ' '\n' | grep "bin/""touch""$$" | head -n 1)

.PHONY: all
all: $(MO_LIST)

.PHONY: update-po
update-po: pot $(PO_LIST)

.PHONY: pot
pot:
ifeq ($(XGETTEXT), )
	@ $(PRINTF) "\033[1;31mERROR: 'xgettext' command can NOT found!\033[0m\n"
	@ $(PRINTF) "\033[1;31mERROR: gettext package is needed to make pot. ABORT!\033[0m\n"
	@ exit 1
endif
ifeq ($(MSGCMP), )
	@ $(PRINTF) "\033[1;31mERROR: 'msgcmp' command can NOT found!\033[0m\n"
	@ $(PRINTF) "\033[1;31mERROR: gettext package is needed to make pot. ABORT!\033[0m\n"
	@ exit 1
endif
	@ cd ../src ; \
	$(XGETTEXT) $(XGETTEXT_PARAMETER) --add-comments='TRANSLATE NOTE:' -o ../po/$(BINARY).po *.c
	@#  echo '' >> $(BINARY).po
	@#  echo 'msgid "A light and easy to use libvte based X Terminal Emulator"' >> $(BINARY).po
	@#  echo 'msgstr ""' >> $(BINARY).po
	@ if ($(MSGCMP) $(MSGCMP_PARAMETER) $(BINARY).pot $(BINARY).po > /dev/null 2>&1) then \
		rm $(BINARY).po ; \
	else \
		$(PRINTF) "\033[1;36m** creating $(BINARY).pot...\033[0m\n" ; \
		mv $(BINARY).po $(BINARY).pot ; \
		echo "" ; \
	fi

$(BINARY).pot: pot

.PHONY: reset
reset:
	@ $(TOUCH) $(BINARY).pot

.PHONY: po
po: $(PO_LIST)

%.po: $(BINARY).pot
ifeq ($(MSGMERGE), )
	@ $(PRINTF) "\033[1;31mERROR: 'msgmerge' command can NOT found!\033[0m\n"
	@ $(PRINTF) "\033[1;31mERROR: gettext package is needed to make po files. ABORT!\033[0m\n"
	@ exit 1
endif
	@ $(PRINTF) "\033[1;33m** msgmerge $@...\033[0m\n"
	-@ $(MSGMERGE) $(MSGMERGE_PARAMETER) $@ $< -o $@

%.mo: %.po $(BINARY).pot
ifeq ($(MSGFMT), )
	@ $(PRINTF) "\033[1;31mERROR: 'msgfmt' command can NOT found!\033[0m\n"
	@ $(PRINTF) "\033[1;31mERROR: gettext package is needed to make mo files. ABORT!\033[0m\n"
	@ exit 1
endif
	@ $(PRINTF) "\033[1;33m** creating $@...\033[0m\n"
	-@ $(MSGFMT) --check --statistics $< -o $@

.PHONY: clean
clean:
	@ for FILE in $(MO_LIST); do \
		if [ -f $$FILE ]; then \
			$(PRINTF) "\033[1;35m** deleting $$FILE...\033[0m\n" ; \
			rm $$FILE ; \
		fi ; \
	done

.PHONY: install
install: all
	@ for FILE in $(LANG_LIST); do \
		if [ -f $$FILE.mo ]; then \
			install -d $(DESTDIR)/$(LOCALEDIR)/$$FILE/LC_MESSAGES/ ; \
			$(PRINTF) "\033[1;33m** installing $$FILE.mo to $(DESTDIR)/$(LOCALEDIR)/$$FILE/LC_MESSAGES/...\033[0m\n" ; \
			install -m 644 $$FILE.mo $(DESTDIR)/$(LOCALEDIR)/$$FILE/LC_MESSAGES/$(BINARY).mo ; \
		fi ; \
	done

.PHONY: uninstall
uninstall:
	@ - for FILE in $(LANG_LIST); do \
		if [ -f $(DESTDIR)/$(LOCALEDIR)/$$FILE/LC_MESSAGES/$(BINARY).mo ]; then \
			$(PRINTF) "\033[1;35m** deleting $(DESTDIR)/$(LOCALEDIR)/$$FILE/LC_MESSAGES/$(BINARY).mo...\033[0m\n" ; \
			rm "$(DESTDIR)/$(LOCALEDIR)/$$FILE/LC_MESSAGES/$(BINARY).mo" ; \
			DirName="$(DESTDIR)/$(LOCALEDIR)/$$FILE/LC_MESSAGES/" ; \
			until [ -n "`ls -A $$DirName`" -o "$$DirName" = "$(DESTDIR)/$(PREFIX)" ]; do \
				$(PRINTF) "\033[1;35m** deleting $$DirName...\033[0m\n" ; \
				rmdir "$$DirName" ; \
				DirName=`dirname $$DirName` ; \
			done \
		else \
			$(PRINTF) "\033[1;31m** $(DESTDIR)/$(LOCALEDIR)/$$FILE is NOT exist!\033[0m\n" ; \
		fi ; \
	done

=== src/Makefile ===
# This is a sample Makefile for debuging LilyTerm.
#
# Usage:
#	make clean: delete lilyterm binary files.
#	make debug: compile lilyeterm_dbg with CLAGS -g.
#	make dev: compile lilyeterm_dev with CLAGS -g.
#	make ddev: compile lilyeterm_dev with -DSAFEMODE compile option.
#	make ut: run a tiny unit testing script with gdb debug information.
#	make uto: build *.o binary files for using in the unit testing programs.
#	make utb: build the the unit testing programs only.
#	make utd: run a tiny unit testing script with full runtime debug information.
#	make utf: run a tiny unit testing script with glib, gtk, gdb and valgrind debug information.
#	make geometry: compile lilyeterm_dev with geometry debug information.
#	make detail: compile lilyeterm_dev with detail runtime debug information.
#	make full: compile lilyeterm_dev with full runtime debug information.
#	make memory: compile lilyeterm_dev for memory lack testing.
#	make data: compile po and $(BINARY).conf files.
#
# grep 'g_debug *( *" *[^\!@+\?-]' * | grep -v '\/\/'
# ([cdfmnpw][aeior][naistgo][sltnucefpd].*\.c:[0-9]*)

include ../.default
-include ../.config

PKGCONFIG := $(shell whereis "pkg-config" | tr -s ' ' '\n' | grep "bin/""pkg-config""$$" | head -n 1)

VTE ?= ""

ifneq ($(PKGCONFIG), )

ifeq ($(VTE), "vte")
GTK := $(shell $(PKGCONFIG) --exists 'gtk+-2.0' && $(ECHO) 'gtk+-2.0')
endif
ifeq ($(VTE), "vte-2.90")
GTK := $(shell $(PKGCONFIG) --exists 'gtk+-3.0' && $(ECHO) 'gtk+-3.0')
endif
ifeq ($(VTE), "")
VTE := $(shell $(PKGCONFIG) --exists 'vte' && $(ECHO) 'vte')
GTK := $(shell $(PKGCONFIG) --exists 'gtk+-2.0' && $(ECHO) 'gtk+-2.0')
endif
ifeq ($(VTE), )
VTE := $(shell $(PKGCONFIG) --exists 'vte-2.90' && $(ECHO) 'vte-2.90')
GTK := $(shell $(PKGCONFIG) --exists 'gtk+-3.0' && $(ECHO) 'gtk+-3.0')
endif

endif

BINDIR = $(PREFIX)/bin
date = `date +%Y-%m-%d`
CC ?= gcc
CFLAGS ?= -Wall -Werror -Os
#CFLAGS = $$CFLAGS -Wall -Wextra -Os -std=c99 \
#	 -DG_DISABLE_DEPRECATED \
#	 -DG_DISABLE_SINGLE_INCLUDES -DGDK_DISABLE_DEPRECATED \
#	 -DGDK_DISABLE_SINGLE_INCLUDES -DGTK_DISABLE_DEPRECATED \
#	 -DGTK_DISABLE_SINGLE_INCLUDES -DGSEAL_ENABLE
LDFLAGS += -L$(prefix)/local/lib
OBJ_PKG_CMD = $(PKGCONFIG) --cflags $(GTK) $(VTE)
BINARY_PKG_CMD = $(PKGCONFIG) --cflags --libs $(GTK) $(VTE)
SOURCE_FILES = menu.c profile.c dialog.c pagename.c notebook.c font.c \
	       property.c window.c misc.c console.c main.c
OBJ = $(SOURCE_FILES:.c=.o)

AUTHOR_CONVERT = $(shell echo "$(AUTHOR)" | sed -e 's/\([ ()]\)/\\\1/g')

INCLUDES = -DBINARY=\"$(BINARY)\" \
	   -DPACKAGE=\"$(PACKAGE)\" \
	   -DBUGREPORT=\"$(BUGREPORT)\" \
	   -DMAINSITE=\"$(MAINSITE)\" \
	   -DGITHUBURL=\"$(GITHUBURL)\" \
	   -DBLOG=\"$(BLOG)\" \
	   -DWIKI=\"$(WIKI)\" \
	   -DISSUES=\"$(ISSUES)\" \
	   -DIRC=\"$(IRC)\" \
	   -DYEAR=\"$(YEAR)\" \
	   -DETCDIR=\"$(ETCDIR)\" \
	   -DLOCALEDIR=\"$(LOCALEDIR)\" \
	   -DICONDIR=\"$(ICONDIR)\"

ifeq ($(BSD), 1)
	INCLUDES += -DBSD
endif

.PHONY: all
all: default
ifeq ($(STRIP), Y)
	@ strip --remove-section=.comment --remove-section=.note $(BINARY)
endif

.PHONY: default
default: CFLAGS := $(CFLAGS) -DSAFEMODE
default: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DVERSION=\"$(VERSION)\ \($(date)\)\"
ifeq ($(DEBUG), Y)
default: INCLUDES += -DDEBUG -DFATAL
endif
default: $(BINARY)

.PHONY: debug
debug: CFLAGS := $(CFLAGS) -g
debug: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DDEBUG -DFATAL -DVERSION=\"$(VERSION)\ Debug\ Version\ \($(date)\)\"
debug: BINARY := $(BINARY)_dbg
debug: $(BINARY)

.PHONY: dev
dev: develop
.PHONY: develop
# develop: CFLAGS := -pedantic -pipe -fno-common -W -Wall -Wcast-align -Wformat=2 -Wpointer-arith -Wundef -Waggregate-return -Wcast-qual -Wmissing-declarations -Wnested-externs -Wstrict-prototypes -O3 -g
develop: CFLAGS := $(CFLAGS) -g
develop: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DDEBUG -DFATAL -DDEVELOP -DVERSION=\"$(VERSION)\ Develop\ Version\ \($(date)\)\"
develop: BINARY := $(BINARY)_dev
develop: $(BINARY)

.PHONY: ddev
ddev: defensive-develop
.PHONY: defensive-develop
defensive-develop: CFLAGS := $(CFLAGS) -g
defensive-develop: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DSAFEMODE -DDEBUG -DFATAL -DDEVELOP -DVERSION=\"$(VERSION)\ Develop\ Version\ \($(date)\)\"
defensive-develop: BINARY := $(BINARY)_dev
defensive-develop: $(BINARY)

.PHONY: detail
detail: CFLAGS := $(CFLAGS) -g
detail: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DGEOMETRY -DDEBUG -DFATAL -DDEVELOP -DDETAIL -DVERSION=\"$(VERSION)\ Develop\ Version\ \($(date)\)\"
detail: BINARY := $(BINARY)_dev
detail: $(BINARY)

.PHONY: full
full: CFLAGS = -Wall -Werror -Wformat -Wformat-security -Werror=format-security -Os -g
full: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DGEOMETRY -DDEBUG -DFATAL -DDEVELOP -DDETAIL -DFULL -DVERSION=\"$(VERSION)\ Develop\ Version\ \($(date)\)\"
full: BINARY := $(BINARY)_dev
full: $(BINARY)

.PHONY: geometry
geometry: CFLAGS := $(CFLAGS) -g
geometry: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DGEOMETRY -DDEBUG -DFATAL -DDEVELOP -DVERSION=\"$(VERSION)\ Develop\ Version\ \($(date)\)\"
geometry: BINARY := $(BINARY)_dev
geometry: $(BINARY)

.PHONY: ut
ut: unit_test
.PHONY: unit_test
unit_test: CFLAGS := $(CFLAGS) -g
unit_test: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(PACKAGE)\" -DSAFEMODE -DDEBUG -DFATAL -DDEVELOP -DUNIT_TEST -DVERSION=\"$(VERSION)_UNIT_TEST_$(date)\"
unit_test: $(OBJ)
	@ sh unit_test.sh "$(INCLUDES)" --enable-gdb --test_all

.PHONY: uto
uto: unit_test_object
.PHONY: unit_test_object
unit_test_object: CFLAGS := $(CFLAGS) -g
unit_test_object: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(PACKAGE)\" -DSAFEMODE -DGEOMETRY -DDEBUG -DFATAL -DDEVELOP -DDETAIL -DFULL -DUNIT_TEST -DVERSION=\"$(VERSION)_UNIT_TEST_$(date)\"
unit_test_object: $(OBJ)

.PHONY: utb
utb: unit_test_build
.PHONY: unit_test_build
unit_test_build: CFLAGS := $(CFLAGS) -g
unit_test_build: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(PACKAGE)\" -DSAFEMODE -DGEOMETRY -DDEBUG -DFATAL -DDEVELOP -DDETAIL -DFULL -DUNIT_TEST -DVERSION=\"$(VERSION)_UNIT_TEST_$(date)\"
unit_test_build: $(OBJ)
	@ sh unit_test.sh "$(INCLUDES)" --build_program_only

.PHONY: utd
utd: unit_test_debug
.PHONY: unit_test_debug
unit_test_debug: CFLAGS := $(CFLAGS) -g
unit_test_debug: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(PACKAGE)\" -DSAFEMODE -DGEOMETRY -DDEBUG -DFATAL -DDEVELOP -DDETAIL -DFULL -DUNIT_TEST -DVERSION=\"$(VERSION)_UNIT_TEST_$(date)\"
unit_test_debug: $(OBJ)
	@ sh unit_test.sh "$(INCLUDES)" --enable-glib-debugger --enable-gtk-debugger --enable-gdb

.PHONY: utf
utf: unit_test_full
.PHONY: unit_test_full
unit_test_full: CFLAGS := $(CFLAGS) -g
unit_test_full: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(PACKAGE)\" -DSAFEMODE -DDEBUG -DFATAL -DDEVELOP -DUNIT_TEST -DVERSION=\"$(VERSION)_UNIT_TEST_$(date)\"
unit_test_full: $(OBJ)
	@ sh unit_test.sh "$(INCLUDES)" --enable-glib-debugger --enable-gtk-debugger --enable-gdb --enable-valgrind

.PHONY: memory
memory: CFLAGS = -Wall -Wformat -Wformat-security -Werror=format-security -O2
memory: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DDEBUG -DFATAL -DDEVELOP -DSAFEMODE -DOUT_OF_MEMORY -DVERSION=\"$(VERSION)\ Develop\ Version\ \($(date)\)\"
memory: BINARY := $(BINARY)_dev
memory: $(BINARY)

.PHONY: clean
clean:
	-@ for FileName in $(BINARY) $(BINARY)_dev $(BINARY)_dbg $(OBJ) unit_test unit_test.[co] gdb_batch gdb.log valgrind.log vgcore.*; \
	do \
		if [ -f "$$FileName" ]; then \
			$(PRINTF) "\033[1;35m** deleting $$FileName...\033[0m\n"; \
			rm "$$FileName"; \
		fi; \
	done

%.o: %.c %.h data.h $(BINARY).h
	@ $(PRINTF) "\033[1;33m** compiling $@...\033[0m\n"
	@ $(CC) $(CPPFLAGS) $(CFLAGS) $(INCLUDES) -c $< `$(OBJ_PKG_CMD)`

$(BINARY): $(OBJ)
	@ $(PRINTF) "\033[1;36m** compiling $(BINARY)...\033[0m\n"
	@ $(CC) $(LDFLAGS) $(CPPFLAGS) $(CFLAGS) -o $(BINARY) $(OBJ) `$(BINARY_PKG_CMD)`

.PHONY: data
data: debug
	@ $(MAKE) -C ../po po

.PHONY: install
install: $(BINARY)
	@ install -d $(DESTDIR)/$(BINDIR)
	@ if [ -f $(BINARY) ]; then \
		$(PRINTF) "\033[1;33m** installing $(BINARY) to $(DESTDIR)/$(BINDIR)...\033[0m\n" ; \
		install -m 755 $(BINARY) $(DESTDIR)/$(BINDIR) ; \
	fi ; \

.PHONY: uninstall
uninstall:
	@ - if [ -f $(DESTDIR)/$(BINDIR)/$(BINARY) ]; then \
		$(PRINTF) "\033[1;35m** deleting $(DESTDIR)/$(BINDIR)/$(BINARY)...\033[0m\n" ; \
		rm "$(DESTDIR)/$(BINDIR)/$(BINARY)" ; \
		DirName="$(DESTDIR)/$(BINDIR)" ; \
		until [ -n "`ls -A $$DirName`" -o "$$DirName" = "$(DESTDIR)/$(PREFIX)" ]; do \
			$(PRINTF) "\033[1;35m** deleting $$DirName...\033[0m\n" ; \
			rmdir "$$DirName" ; \
			DirName=`dirname $$DirName` ; \
		done \
	else \
		$(PRINTF) "\033[1;31m** $(DESTDIR)/$(BINDIR)/$(BINARY) is NOT exist!\033[0m\n" ; \
	fi

=== debian/changelog ===
lilyterm (0.9.9.4-4) unstable; urgency=medium

  [ ChangZhuo Chen (陳昌倬) ]
  * Bump Standards-Version to 3.9.6
  * Update Vcs-*

  [ Wei-Cheng Pan (潘韋成) ]
  * Fix hard-coded Firefox as browser (Closes: #794961)

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Tue, 11 Aug 2015 21:15:57 +0800

lilyterm (0.9.9.4-3) unstable; urgency=medium

  * Fix wrong locale file name (Closes: #757080)

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Tue, 05 Aug 2014 20:03:01 +0800

lilyterm (0.9.9.4-2) unstable; urgency=medium

  * Add Vcs information
  * Provides: x-terminal-emulator.
    Thanks to Charles Malaheenee (Closes: #756609)
  * Add libgtk2.0-dev as Build-Depends

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Fri, 01 Aug 2014 19:46:13 +0800

lilyterm (0.9.9.4-1) unstable; urgency=low

  * Initial release (Closes: #752406)

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Thu, 26 Jun 2014 19:22:03 +0800

=== debian/control ===
Source: lilyterm
Section: x11
Priority: optional
Maintainer: ChangZhuo Chen (陳昌倬) <czchen@gmail.com>
Build-Depends: debhelper (>= 9),
               autotools-dev,
               dh-autoreconf,
               gettext,
               intltool,
               libgtk2.0-dev,
               libvte-dev,
Standards-Version: 3.9.6
Homepage: http://lilyterm.luna.com.tw/
Vcs-Git: git://anonscm.debian.org/collab-maint/lilyterm.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/lilyterm.git

Package: lilyterm
Provides: x-terminal-emulator
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Light and eazy-to-use terminal emulator for X
 LilyTerm is a terminal emulator for the X Window System, based on the libvte
 library, and aims to be fast and lightweight.
 .
 LilyTerm features the ability to use multiple terminals in a single window and
 customize key binding.

Package: lilyterm-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends},
         lilyterm (= ${binary:Version}),
Description: Debug symbols for lilyterm
 LilyTerm is a terminal emulator for the X Window System, based on the libvte
 library, and aims to be fast and lightweight.
 .
 LilyTerm features the ability to use multiple terminals in a single window and
 customize key binding.
 .
 This package contains debug symbols for lilyterm.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	mkdir -p $(CURDIR)/debian/bak
	cp $(CURDIR)/configure.ac $(CURDIR)/debian/bak

	mkdir -p $(CURDIR)/debian/bak/src
	cp $(CURDIR)/src/Makefile.am $(CURDIR)/debian/bak/src

	mkdir -p $(CURDIR)/debian/bak/po
	cp $(CURDIR)/po/lilyterm.pot $(CURDIR)/debian/bak/po

	./autogen.sh
	dh_auto_configure -- --disable-silent-rules

override_dh_auto_clean:
	dh_auto_clean
	-cp $(CURDIR)/debian/bak/configure.ac $(CURDIR)
	-cp $(CURDIR)/debian/bak/src/Makefile.am $(CURDIR)/src
	-cp $(CURDIR)/debian/bak/po/lilyterm.pot $(CURDIR)/po

override_dh_strip:
	dh_strip --dbg-package=lilyterm-dbg

override_dh_installchangelogs:
	dh_installchangelogs $(CURDIR)/ChangeLog --keep upstream

override_dh_auto_install:
	dh_auto_install
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/lilyterm/COPYING

## lilyterm 0.9.9.4%2Bgit20150208.f600c0

=== debian/changelog ===
lilyterm (0.9.9.4+git20150208.f600c0-5build1) jammy; urgency=medium

  * No-change rebuild against latest gdk-pixbuf

 -- Jeremy Bicha <jeremy.bicha@canonical.com>  Wed, 09 Mar 2022 18:52:41 -0500

lilyterm (0.9.9.4+git20150208.f600c0-5) unstable; urgency=medium

  * Merge upstream commit to fix empty environment variable in new tabs
    (Closes: #825928).
  * Bump compat to 10.
  * Update Vcs-Browser.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 22 Jan 2017 20:12:04 +0800

lilyterm (0.9.9.4+git20150208.f600c0-4) unstable; urgency=medium

  * Make the build reproducible.
    Thanks to Chris Lamb (Closes: #835376)
  * Bump Standards-Version to 3.9.8.
  * Update Vcs-* fields.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 24 Oct 2016 18:52:52 +0800

lilyterm (0.9.9.4+git20150208.f600c0-3) unstable; urgency=medium

  * Fix wrong version in dbg to dbgsym migration.
  * Don't install COPYING.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 26 Dec 2015 01:29:06 +0800

lilyterm (0.9.9.4+git20150208.f600c0-2) unstable; urgency=medium

  * Remove lilyterm-dbg in favor of dbgsym.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 21 Dec 2015 22:04:18 +0800

lilyterm (0.9.9.4+git20150208.f600c0-1) unstable; urgency=medium

  [ Yao-Po Wang ]
  * Non-maintainer upload
  * let the lilyterm support libvte-2.91 (Closes: #790181)
  * Integrate upstream up to f600c086
  * Remove 0001-Fix-hard-coded-URL-handlers.patch, locale.patch, and
    manpage-minus.patch that all included in current source.

  [ ChangZhuo Chen (陳昌倬) ]
  * Fix debian/rules.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 28 Nov 2015 02:20:55 +0800

## lilyterm 0.9.9.4+git20150208.f600c0

=== Makefile ===
# This is a sample Makefile for debuging LilyTerm.
#
# Usage:
#	make clean: delete lilyterm binary files.
#	make debug: compile lilyeterm_dbg with CLAGS -g.
#	make dev: compile lilyeterm_dev with CLAGS -g.
#	make vdev: compile lilyeterm_dev with full compiling command message.
#	make ddev: compile lilyeterm_dev with -DSAFEMODE compile option.
#	make ut: run a tiny unit testing script with gdb debug information.
#	make uto: build *.o binary files for using in the unit testing programs.
#	make utb: build the the unit testing programs only.
#	make utd: run a tiny unit testing script with full runtime debug information.
#	make utf: run a tiny unit testing script with glib, gtk, gdb and valgrind debug information.
#	make geometry: compile lilyeterm_dev with geometry debug information.
#	make detail: compile lilyeterm_dev with detail runtime debug information.
#	make full: compile lilyeterm_dev with full runtime debug information.
#	make memory: compile lilyeterm_dev for memory lack testing.
#	make data: compile po and $(BINARY).conf files.
#
# grep 'g_debug *( *" *[^\!@+\?-]' * | grep -v '\/\/'
# (\(console\|dialog\|font\|main\|menu\|misc\|notebook\|pagename\|profile\|property\|window\).c:[0-9]*)
# MANWIDTH=80 man data/lilyterm.1 | col -b > README

include ../.default
-include ../.config

PKGCONFIG := $(shell whereis "pkg-config" | tr -s ' ' '\n' | grep "bin/""pkg-config""$$" | head -n 1)
STRIP := $(shell whereis "strip" | tr -s ' ' '\n' | grep "bin/""strip""$$" | head -n 1)

VTE ?=

ifneq ($(PKGCONFIG), )

ifeq ($(VTE), vte)
GTK := $(shell $(PKGCONFIG) --exists 'gtk+-2.0' && $(ECHO) 'gtk+-2.0')
endif
ifeq ($(VTE), vte-2.91)
GTK := $(shell $(PKGCONFIG) --exists 'gtk+-3.0' && $(ECHO) 'gtk+-3.0')
endif
ifeq ($(VTE), vte-2.90)
GTK := $(shell $(PKGCONFIG) --exists 'gtk+-3.0' && $(ECHO) 'gtk+-3.0')
endif
ifeq ($(VTE), )
VTE := $(shell $(PKGCONFIG) --exists 'vte' && $(ECHO) 'vte')
GTK := $(shell $(PKGCONFIG) --exists 'gtk+-2.0' && $(ECHO) 'gtk+-2.0')
endif
ifeq ($(VTE), )
VTE := $(shell $(PKGCONFIG) --exists 'vte-2.91' && $(ECHO) 'vte-2.91')
GTK := $(shell $(PKGCONFIG) --exists 'gtk+-3.0' && $(ECHO) 'gtk+-3.0')
endif
ifeq ($(VTE), )
VTE := $(shell $(PKGCONFIG) --exists 'vte-2.90' && $(ECHO) 'vte-2.90')
GTK := $(shell $(PKGCONFIG) --exists 'gtk+-3.0' && $(ECHO) 'gtk+-3.0')
endif

endif

BINDIR = $(PREFIX)/bin
date = `date +%Y-%m-%d`
CC ?= gcc
CFLAGS ?= -Wall -Werror -Os
#CFLAGS = $$CFLAGS -Wall -Wextra -Os -std=c99 \
#	 -DG_DISABLE_DEPRECATED \
#	 -DG_DISABLE_SINGLE_INCLUDES -DGDK_DISABLE_DEPRECATED \
#	 -DGDK_DISABLE_SINGLE_INCLUDES -DGTK_DISABLE_DEPRECATED \
#	 -DGTK_DISABLE_SINGLE_INCLUDES -DGSEAL_ENABLE
LDFLAGS += -L$(prefix)/local/lib
ifeq ($(VTE), vte-2.91)
LDFLAGS += -lX11
endif
OBJ_PKG_CMD = $(PKGCONFIG) --cflags $(GTK) $(VTE)
BINARY_PKG_CMD = $(PKGCONFIG) --cflags --libs $(GTK) $(VTE)
SOURCE_FILES = menu.c profile.c dialog.c pagename.c notebook.c font.c \
	       property.c window.c misc.c console.c main.c
OBJ = $(SOURCE_FILES:.c=.o)

AUTHOR_CONVERT = $(shell echo "$(AUTHOR)" | sed -e 's/\([ ()]\)/\\\1/g')

INCLUDES = -DBINARY=\"$(BINARY)\" \
	   -DPACKAGE=\"$(PACKAGE)\" \
	   -DBUGREPORT=\"$(BUGREPORT)\" \
	   -DMAINSITE=\"$(MAINSITE)\" \
	   -DGITHUBURL=\"$(GITHUBURL)\" \
	   -DBLOG=\"$(BLOG)\" \
	   -DWIKI=\"$(WIKI)\" \
	   -DISSUES=\"$(ISSUES)\" \
	   -DIRC=\"$(IRC)\" \
	   -DYEAR=\"$(YEAR)\" \
	   -DETCDIR=\"$(ETCDIR)\" \
	   -DLOCALEDIR=\"$(LOCALEDIR)\" \
	   -DICONDIR=\"$(ICONDIR)\"

ifeq ($(BSD), 1)
	INCLUDES += -DBSD
endif
ifeq ($(VERBOSITY), Y)
	VERBOSITY_OUTPUT =
else
	VERBOSITY_OUTPUT = @
endif

.PHONY: all
all: default
ifeq ($(DEBUG), N)
	@ $(PRINTF) "\033[1;36m** striping \033[1;32m$(BINARY)\033[1;36m ...\033[0m\n"
	$(VERBOSITY_OUTPUT) $(STRIP) --remove-section=.comment --remove-section=.note $(BINARY)
endif

.PHONY: default
ifneq ($(SAFEMODE), N)
default: CFLAGS += -DSAFEMODE
else
default: CFLAGS += -DREALMODE
endif
default: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DVERSION=\"$(VERSION)\ \($(date)\)\"
ifeq ($(DEBUG), Y)
default: INCLUDES += -DDEBUG -DFATAL
endif
default: $(BINARY)

.PHONY: debug
debug: CFLAGS := $(CFLAGS) -g
debug: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DDEBUG -DFATAL -DFORCE_ENABLE_VTE_BACKGROUND -DVERSION=\"$(VERSION)\ Debug\ Version\ \($(date)\)\"
debug: BINARY := $(BINARY)_dbg
debug: $(BINARY)

.PHONY: dev
dev: develop
.PHONY: develop
# develop: CFLAGS := -pedantic -pipe -fno-common -W -Wall -Wcast-align -Wformat=2 -Wpointer-arith -Wundef -Waggregate-return -Wcast-qual -Wmissing-declarations -Wnested-externs -Wstrict-prototypes -O3 -g
develop: CFLAGS := $(CFLAGS) -g
develop: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DREALMODE -DDEBUG -DFATAL -DFORCE_ENABLE_VTE_BACKGROUND -DDEVELOP -DVERSION=\"$(VERSION)\ Develop\ Version\ \($(date)\)\"
develop: BINARY := $(BINARY)_dev
develop: $(BINARY)

.PHONY: vdev
vdev: verbosity-output
.PHONY: verbosity-output
verbosity-output: VERBOSITY_OUTPUT :=
verbosity-output: develop

.PHONY: ddev
ddev: defensive-develop
.PHONY: defensive-develop
defensive-develop: CFLAGS := $(CFLAGS) -g
defensive-develop: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DSAFEMODE -DDEBUG -DFATAL -DDEVELOP -DVERSION=\"$(VERSION)\ Develop\ Version\ \($(date)\)\"
defensive-develop: BINARY := $(BINARY)_dev
defensive-develop: $(BINARY)

.PHONY: detail
detail: CFLAGS := $(CFLAGS) -g
detail: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DGEOMETRY -DDEBUG -DFATAL -DDEVELOP -DDETAIL -DVERSION=\"$(VERSION)\ Develop\ Version\ \($(date)\)\"
detail: BINARY := $(BINARY)_dev
detail: $(BINARY)

.PHONY: full
full: CFLAGS = -Wall -Werror -Wformat -Wformat-security -Werror=format-security -Os -g
full: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DGEOMETRY -DDEBUG -DFATAL -DDEVELOP -DDETAIL -DFULL -DVERSION=\"$(VERSION)\ Develop\ Version\ \($(date)\)\"
full: BINARY := $(BINARY)_dev
full: $(BINARY)

.PHONY: geometry
geometry: CFLAGS := $(CFLAGS) -g
geometry: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DGEOMETRY -DDEBUG -DFATAL -DDEVELOP -DVERSION=\"$(VERSION)\ Develop\ Version\ \($(date)\)\"
geometry: BINARY := $(BINARY)_dev
geometry: $(BINARY)

.PHONY: ut
ut: unit_test
.PHONY: unit_test
unit_test: CFLAGS := $(CFLAGS) -g
unit_test: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(PACKAGE)\" -DSAFEMODE -DDEBUG -DFATAL -DDEVELOP -DUNIT_TEST -DVERSION=\"$(VERSION)_UNIT_TEST_$(date)\"
unit_test: $(OBJ)
	@ sh unit_test.sh "$(INCLUDES)" --enable-gdb --test_all

.PHONY: uto
uto: unit_test_object
.PHONY: unit_test_object
unit_test_object: CFLAGS := $(CFLAGS) -g
unit_test_object: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(PACKAGE)\" -DSAFEMODE -DGEOMETRY -DDEBUG -DFATAL -DDEVELOP -DDETAIL -DFULL -DUNIT_TEST -DVERSION=\"$(VERSION)_UNIT_TEST_$(date)\"
unit_test_object: $(OBJ)

.PHONY: utb
utb: unit_test_build
.PHONY: unit_test_build
unit_test_build: CFLAGS := $(CFLAGS) -g
unit_test_build: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(PACKAGE)\" -DSAFEMODE -DGEOMETRY -DDEBUG -DFATAL -DDEVELOP -DDETAIL -DFULL -DUNIT_TEST -DVERSION=\"$(VERSION)_UNIT_TEST_$(date)\"
unit_test_build: $(OBJ)
	@ sh unit_test.sh "$(INCLUDES)" --build_program_only

.PHONY: utd
utd: unit_test_debug
.PHONY: unit_test_debug
unit_test_debug: CFLAGS := $(CFLAGS) -g
unit_test_debug: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(PACKAGE)\" -DSAFEMODE -DGEOMETRY -DDEBUG -DFATAL -DDEVELOP -DDETAIL -DFULL -DUNIT_TEST -DVERSION=\"$(VERSION)_UNIT_TEST_$(date)\"
unit_test_debug: $(OBJ)
	@ sh unit_test.sh "$(INCLUDES)" --enable-glib-debugger --enable-gtk-debugger --enable-gdb

.PHONY: utf
utf: unit_test_full
.PHONY: unit_test_full
unit_test_full: CFLAGS := $(CFLAGS) -g
unit_test_full: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(PACKAGE)\" -DSAFEMODE -DDEBUG -DFATAL -DDEVELOP -DUNIT_TEST -DVERSION=\"$(VERSION)_UNIT_TEST_$(date)\"
unit_test_full: $(OBJ)
	@ sh unit_test.sh "$(INCLUDES)" --enable-glib-debugger --enable-gtk-debugger --enable-gdb --enable-valgrind

.PHONY: memory
memory: CFLAGS = -Wall -Wformat -Wformat-security -Werror=format-security -O2
memory: INCLUDES := $(INCLUDES) -DAUTHOR=\"$(AUTHOR_CONVERT)\" -DDEBUG -DFATAL -DDEVELOP -DSAFEMODE -DOUT_OF_MEMORY -DVERSION=\"$(VERSION)\ Develop\ Version\ \($(date)\)\"
memory: BINARY := $(BINARY)_dev
memory: $(BINARY)

.PHONY: clean
clean:
	-@ for FileName in $(BINARY) $(BINARY)_dev $(BINARY)_dbg $(OBJ) unit_test unit_test.[co] gdb_batch gdb.log valgrind.log vgcore.*; \
	do \
		if [ -f "$$FileName" ]; then \
			$(PRINTF) "\033[1;35m** deleting \033[1;32m$$FileName\033[1;35m ...\033[0m\n"; \
			rm "$$FileName"; \
		fi; \
	done

%.o: %.c %.h data.h $(BINARY).h
	@ $(PRINTF) "\033[1;33m** compiling \033[1;32m$@\033[1;33m ...\033[0m\n"
	$(VERBOSITY_OUTPUT) $(CC) $(CPPFLAGS) $(CFLAGS) $(INCLUDES) -c $< `$(OBJ_PKG_CMD)`

$(BINARY): $(OBJ)
	@ $(PRINTF) "\033[1;36m** compiling \033[1;32m$(BINARY)\033[1;36m ...\033[0m\n"
	$(VERBOSITY_OUTPUT) $(CC) $(LDFLAGS) $(CPPFLAGS) $(CFLAGS) -o $(BINARY) $(OBJ) `$(BINARY_PKG_CMD)`

.PHONY: data
data: debug
	@ $(MAKE) -C ../po po

.PHONY: install
install: $(BINARY)
	@ install -d $(DESTDIR)/$(BINDIR)
	@ if [ -f $(BINARY) ]; then \
		$(PRINTF) "\033[1;33m** installing \033[1;32m$(BINARY)\033[1;33m to \033[1;34m$(DESTDIR)/$(BINDIR)\033[1;33m ...\033[0m\n" ; \
		install -m 755 $(BINARY) $(DESTDIR)/$(BINDIR) ; \
	fi ; \

.PHONY: uninstall
uninstall:
	@ - if [ -f $(DESTDIR)/$(BINDIR)/$(BINARY) ]; then \
		$(PRINTF) "\033[1;35m** deleting \033[1;32m$(DESTDIR)/$(BINDIR)/$(BINARY)\033[1;35m ...\033[0m\n" ; \
		rm "$(DESTDIR)/$(BINDIR)/$(BINARY)" ; \
		DirName="$(DESTDIR)/$(BINDIR)" ; \
		until [ -n "`ls -A $$DirName`" -o "$$DirName" = "$(DESTDIR)/$(PREFIX)" ]; do \
			$(PRINTF) "\033[1;35m** deleting directory \033[1;34m$$DirName\033[1;35m ...\033[0m\n" ; \
			rmdir "$$DirName" ; \
			DirName=`dirname $$DirName` ; \
		done \
	else \
		$(PRINTF) "\033[1;31m** \033[1;32m$(DESTDIR)/$(BINDIR)/$(BINARY)\033[1;31m is NOT exist!\033[0m\n" ; \
	fi

=== debian/changelog ===
lilyterm (0.9.9.4+git20150208.f600c0-5build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:51:14 +1100

lilyterm (0.9.9.4+git20150208.f600c0-5build2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:33:50 +0000

=== debian/control ===
Source: lilyterm
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
Build-Depends: debhelper (>= 10),
               autotools-dev,
               dh-autoreconf,
               gettext,
               intltool,
               libvte-2.91-dev,
               libgtk-3-dev,
Standards-Version: 3.9.8
Homepage: http://lilyterm.luna.com.tw/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/lilyterm.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/lilyterm.git

Package: lilyterm
Provides: x-terminal-emulator
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Light and eazy-to-use terminal emulator for X
 LilyTerm is a terminal emulator for the X Window System, based on the libvte
 library, and aims to be fast and lightweight.
 .
 LilyTerm features the ability to use multiple terminals in a single window and
 customize key binding.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with autoreconf

override_dh_autoreconf:
	dh_autoreconf ./autogen.sh

override_dh_auto_configure:
	dh_auto_configure -- --disable-silent-rules

override_dh_strip:
	dh_strip --ddeb-migration='lilyterm-dbg (<< 0.9.9.4+git20150208.f600c0-2~)'

override_dh_installchangelogs:
	dh_installchangelogs $(CURDIR)/ChangeLog --keep upstream

override_dh_auto_install:
	dh_auto_install
	rm -f $(CURDIR)/debian/lilyterm/usr/share/doc/lilyterm/COPYING

=== debian/watch ===
version=3
https://github.com/Tetralet/LilyTerm/releases .*/[vV]?(\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
